# CraftPresence

## [v2.10.0](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v2.10.0) (2023-12-01)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/compare/v2.9.4...v2.10.0) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- [Change] Implemented Blizzard Category Support  
    - This code is pretty cursed, but is honestly the only good way to automate this  
    - If it causes too many issues, it'll be reverted, since it has minimal effect besides ease-of-access  
- [Change] Optimize some Option Data  
    - Options Table is now generated similarly to `DB\_DEFAULTS`  
- [Fix] Re-align config element widths  
    - Fixes certain UI text elements being cut-off  
    - Adds additional padding to other UI elements to have a cleaner UI  
- Merge branch 'next'  
- [Fix] Remove obsolete translations  
- [Fix] Script and Data Sanity Fixes  
    - Fixed an issue in the script with incorrect `next\_pos` calculations causing out-of-bound pixel retrieval (Same Bug from Beta 4, regression occurred in Beta 5)  
    - Increased the minimum `frameHeight` from `1` to `3`  
      - This is both for consistency with the minimum `frameWidth` and for potential issues with the script when using vertical mode and a `frameHeight` less then 3  
- [Fix] Adjusted some baseline positioning calculations  
    - Should resolve some failing cases due to how wow frames work  
- [Change] Add additional anchor support, hopefully fix `frame\_count` issues  
- [Fix] Minor optimization for `pos\_x`, `pos\_y` storage for Frames  
- [Change] Removed the `/cp clear true` command  
    - Originally implemented earlier, this command has been removed due to potential cases of memory leaks since frames cannot be removed without a `/reload`  
    - Further applying of `Advanced Frame Settings` now solely rely on the `Reload UI` function (Either `/reload`, the CraftPresence command, or the `Reload UI` button in the config)  
- [Change] Multiple Changes to the Advanced Frame Settings  
    - Added a summary description for the category, stating in *even more clarity* that the options in said category **require** either a frame/UI reload as well as adjusting the script's config settings  
    - `frameStartX` and `frameStartY` can now use negative values  
    - Moved `frameWidth` and `frameHeight` into the `Advanced Frame Settings` sub-category  
    - Added two buttons for `Reload Frames` and `Reload UI`  
      - These are a replacement to the frames reloading upon setting change (Upon further investigation, doing those reloads too quickly/too often can easily break the entire UI)  
- [Fix] Remove a fallback sanity case in `IsWithinValue`  
    - Said case was preventing negative values from being used in `IsWithinValue`  
- [Fix] Minor optimization for frame creation  
    - `PaintFrame` now is able to fill in the `texture` field if not present  
    - `CreateFrames` now uses `PaintFrame` instead of duplicating logic  
- [Change] `frameStartX` and `frameStartY` are now `range` inputs  
    - May cause breakage to those who were using the betas  
- [Fix] Round the results of `GetScaledWidth` and `GetScaledHeight`  
- [Change] Improved RPC Event Handling  
    - Implements the 2nd part of changes inspired by [AipNoo's RPC mod](https://github.com/AipNooBest/wow-discord-rpc) featuring:  
      - Removal of `seperator` pixels, leading to a much larger event size, as the original addon was indended to have  
      - And the removal of the `pixel\_width` and `pixel\_height` script properties introduced in an earlier commit, but no longer needed with these changes  
    - The RPC Script has been bumped to v1.7.5 to incorporate several refactors to the `read\_squares` method to incorporate the changes made in [this commit](https://github.com/AipNooBest/wow-discord-rpc/commit/4737a629132e5197a811c8982ec6c965b8cfc478)  
    - Updated the About Headers in the Config UI to replace the `Attk4` repo reference with `AipNooBest`. The Attk4 repo that was credited before no longer seems to exist.  
- [Change] Bumped Script to v1.7.3  
    - Fixed a regression in vertical support, where the y-axis was not properly being calculated  
- [Change] Additional Script Improvements  
    - The Event Tag has now been shortened back to `$$$` instead of `$RPCEvent$` so it only uses up one pixel space, not 3.5  
    - Fixed a minor floating-point issue with the for-loop for reading squares  
- [Change] Multi-Commit (See Details)  
    - The `pixel\_size` script property, and the related `frameSize` addon property, have been split into separate values for the width and height of said pixel  
      - The Script has been bumped to v1.7.2 as a result of this change, while the addon has had it's migration schema bumped to `v7` (Migrating the `frameSize` value to the new settings, if able to)  
      - Additionally, these new properties also no longer require a reload, in contrast to `frameSize` previously needing a reload, despite not being mentioned in its tooltip.  
    - Replaced the sanity checks for frame positioning, with values dependent on Scaling  
    - Adjusted frame creation to make it independent of UI scaling, as well as adjusting the frame strata to assist with recently found blurring issues in older clients  
      - Credits to [this commit](https://github.com/AipNooBest/wow-discord-rpc/commit/4737a629132e5197a811c8982ec6c965b8cfc478) for the change inspiration  
    - Fixed issues with the `ERROR\_MESSAGE\_OVERFLOW` being incorrectly coded.  
      - It now is a post-generation check instead of a pre-generation check, and also checks `squares\_painted` for the bytes, not the text length  
- [Fix] Bumped Script to v1.7.1  
    - Fixed an issue in the windows-specific method of RPC Frame Input, where image cropping was done incorrectly.  
- [Change] Implemented Frontend for RPC Frame Customization  
    - Added frontend configurability for `is\_vertical`, `start\_x`, and `start\_y` params  
      - The positional parameters can only be set to in-bounds positions, with sanity checks in place to avoid misuse  
    - Adjusted some documentation to align with the new frontend options  
- [Change] Misc. Documentation Adjustments and Formatting  
- [Fix] Fixed luacheck warning  
- [Fix] Fixed another debug typo  
- [Change] Bumped Script to v1.7.0  
    - Added a new `is\_vertical` property, allowing vertical RPC Frame Support within the script.  
    - Note that other orientation settings in the script's config will need adjusting for this to properly work  
- Merge branch 'master' into next  
- [Fix] Fixed debug typo  
- [Change] Added preliminary support for Vertical positioning and offsets  
    - Added `start\_x` and `start\_y` as offsets for when frame gen should begin at  
    - Added `is\_vertical` for rendering the frames vertically instead of horizontally  
      - Using `BOTTOMLEFT` would require adjusting the `start\_y` offset  
- [Prototype] Begin Prototyping new methods for displaying RPC frames  
    - Added a new option for customizing the `frameAnchor` for the RPC frames (Supporting only `TOPLEFT` and `BOTTOMLEFT` at the moment)  
    - Changing this setting requires adjusting some script properties, primarily the `_offset` and/or `_specific` layout settings  
